{% extends 'base_fullwidth_leaflet.html' %}
{% load leaflet_tags %}
{% leaflet_js %}
{% leaflet_css %}
{% load geojson_tags %}
{% load i18n staticfiles crispy_forms_tags django_tables2 %}
{% block content %}
    <style>
        .leaflet-container-default {
            min-height: 800px;
        }
    </style>

    <h1>{% if createplacebtn %}<a href="{% url 'sights:metaplace_create' %}" class="btn btn-primary pull-right"><i
            class="fa fa-fw fa-map-marker-alt"></i>{% trans 'Créer un métasite' %}</a>{% endif %}<i
            class="{{ icon | safe }}"></i> {{ title | safe }}</h1>

    {% comment %}Tableau de recherche avec filtrage {% endcomment %}
    <div class="col-sm-12 col-md-6 col-lg-7">
        {% if filter %}
            <div class="panel panel-default">
                <div class="panel-body">
                    <form action="" method="get">
                        {% crispy filter.form %}
                    </form>
                </div>
            </div>
        {% endif %}
        {% if count %}
            <div class="panel panel-default">
                <div class="panel-body">
                    {% if export %}
                        <div class="btn-group btn-group-xs pull-right">
                            <button type="button" class="btn btn-primary btn-xs dropdown-toggle" data-toggle="dropdown"
                                    aria-haspopup="true"
                                    aria-expanded="false">
                                {% trans 'Exporter' %} <span class="caret"></span>
                            </button>
                            <ul class="dropdown-menu">
                                <li><a href="{% querystring '_export'='csv' %}"> download as csv</a></li>
                                <li><a href="{% querystring '_export'='ods' %}"> download as ods</a></li>
                                <li><a href="{% querystring '_export'='xls' %}"> download as xlsx</a></li>
                                <li><a href="{% querystring '_export'='xlsx' %}"> download as xls</a></li>
                            </ul>
                        </div>
                    {% endif %}
                    {{ counttitle }} : <b>{{ count }}</b>
                </div>
            </div>
        {% endif %}

        <div class="panel panel-default">
            {% render_table table %}
        </div>

    </div>
    <script type="text/javascript">
        {{ js | safe }}
        $(function () {
            $('[data-toggle="tooltip"]').tooltip()
        })
        $(function () {
            $('[data-toggle="popover"]').popover()
        })
    </script>
    {% if filter %}
        <link rel="stylesheet" href="{% static 'css/select2-bootstrap.min.css' %}">
        <script type="text/javascript">
            {{ js | safe }}
            $.fn.select2.defaults.set("theme", "bootstrap");
        </script>
    {% endif %}

    {#    Carte de recherche#}
    <div class="col-sm-12 col-md-6 col-lg-5">
        {% leaflet_map "main" %}
    </div>

    <script type="text/javascript">

        var circlemarker = null;
        var placeBaseUrl = '{% url 'sights:place_bbox_search_api' %}';
        var metaplaceBaseUrl = '{% url 'sights:metaplace_bbox_search_api' %}';

        
        window.addEventListener("map:init", function (event) {
            var placeMarkers = L.markerClusterGroup({
                chunkedLoading: true,
                spiderfyDistanceMultiplier: 3,
                maxClusterRadius: 14
            });

            var metaPlacePolygons = L.featureGroup();

            var style_data = {
                radius: 6,
                fillColor: "#ff4c41",
                color: "#ddd",
                weight: 2,
                opacity: 1,
                fillOpacity: 0.8
            };

            var style_data_metasite = {
                radius: 6,
                fillColor: "#8A2BE2",
                color: "#ddd",
                weight: 2,
                opacity: 1,
                fillOpacity: 0.8
            };

            var polygon_style = {
                color: "#8A2BE2",
                fillColor: "#9370DB",
                weight: 2,
                opacity: 0.8,
                fillOpacity: 0.2
            };


            var map = event.detail.map;


            // Fonction plein écran
            map.addControl(new L.Control.Fullscreen());


            // Géolocalisation de l'utilisateur

            var locateOptions = {
                flyTo: true,
                title: 'Ma position',
                icon: 'fa fa-location-arrow',
            };

            L.control.locate(locateOptions).addTo(map);

            // Recherche par adresse
            map.addControl(new L.Control.Search({
                url: 'https://nominatim.openstreetmap.org/search?format=json&accept-language=fr-FR&q={s}',
                jsonpParam: 'json_callback',
                propertyName: 'display_name',
                propertyLoc: ['lat', 'lon'],
                markerLocation: true,
                autoType: true,
                autoCollapse: true,
                minLength: 2,
                zoom: 13,
                text: 'Suchen...',
                textCancel: 'Annuler',
                textErr: 'Erreur'
            }));

            // Add legend
            let legend = L.control({position: "bottomleft"});


            legend.onAdd = function (map) {
                let div = L.DomUtil.create("div", "info legend");
                div.setAttribute("onmouseenter", "showDisclaimer()");
                div.setAttribute("onmouseleave", "hideDisclaimer()");
                div.id = "info legend"
                div.innerHTML = "<b class='fa fa-info-circle'></b>";
                return div;
            };
            legend.addTo(map);


            var locationLayer = Object;

            let overlayText = L.control({position: "topright"});
            overlayText.onAdd = function (map) {
                let div = L.DomUtil.create("div", "zoomInfo");
                div.innerHTML += '<p class="label label-warning"><i class="fa fa-info-circle fa-fw"></i>Zoomez pour afficher les données</p>';
                return div;
            };
            overlayText.addTo(map);

            let cancelPlaceSearchRequest;
            const loadPlaces = function () {
                    // Download GeoJSON data with Ajax
                    placeMarkers.clearLayers();
                    map.spin(true);
                    var dataBboxUrl = placeBaseUrl + '?format=json&in_bbox=' + map.getBounds().toBBoxString();
                    if (cancelPlaceSearchRequest) {
                        // Cancel the previous request before making a new request
                        cancelPlaceSearchRequest.cancel();
                    }
                    // Create a new CancelToken
                    cancelPlaceSearchRequest = axios.CancelToken.source();

                    $http.get(dataBboxUrl, {
                        progress: true,
                        cancelToken: cancelPlaceSearchRequest.token
                    })
                        .then(function (resp) {
                            if (resp.status == 200) {
                                return resp.data;
                            }
                        })
                        .catch(function (error) {
                            // handle error
                            if (error.__CANCEL__) {
                                console.log('<loadPlaces axios error> cancelled request')
                            } else {
                                console.log('<loadPlaces Axios error>', error);
                            }
                        })
                        .then(function (data) {
                                if (data.results) {
                                    locationLayer = L.geoJson(data.results, {
                                        onEachFeature: function onEachFeature(feature, layer) {
                                            var props = feature.properties;
                                            var content = '<h3>Site&nbsp;:&nbsp;'
                                                + props.name
                                                + '</h3><p><ul><li><b>Type</b>: '
                                                + (props.type_data ? props.type_data.descr : "Non défini")
                                                + '</li><li><b>Nombre de sessions</b> '
                                                + (props.total_sessions ? props.total_sessions : "Aucune")
                                                + '&nbsp;(Dernière: '
                                                + (props.last_session ? props.last_session.date_start__max : "Aucune")
                                                + ')</li></ul> </p><div class="text-right"><div class="btn-group" role="group"><a type="button" class="btn btn-default btn-sm" align="center" style="color:white;" href="/place/'
                                                + feature.id
                                                + '/detail" target="_blank"><i class="fa fa-fw fa-info-circle"></i></a><a type="button" class="btn btn-info btn-sm" align="center" style="color:white;" href="/place/'
                                                + feature.id
                                                + '/update" target="_blank"><i class="fa fa-fw fa-edit"></i></a></div></div>';
                                            layer.bindPopup(content);
                                        }
                                        ,
                                        pointToLayer: function (feature, latlng) {
                                            // Set a different color if location is in a metaplace
                                            if (feature.properties.metaplace) {
                                                return L.circleMarker(latlng, style_data_metasite);
                                            }
                                            return L.circleMarker(latlng, style_data);
                                        }
                                    });
                                    placeMarkers.addLayer(locationLayer).addTo(map).bringToFront();
                                }
                            }
                        )
                        .catch(function (error) {
                            console.log('<loadPlace leaflet error>', error);
                        })
                        .then(function () {
                            map.spin(false);
                        });
                }
            ;


            // Download GeoJSON data with Axios
            let cancelMetaPlaceSearchRequest;
            loadMetaPlaces = function () {
                metaPlacePolygons.clearLayers()
                if (cancelMetaPlaceSearchRequest) {
                    // Cancel the previous request before making a new request
                    cancelMetaPlaceSearchRequest.cancel();
                }
                // Create a new CancelToken
                cancelMetaPlaceSearchRequest = axios.CancelToken.source();

                $http.get(metaplaceBaseUrl + '?format=json', {
                    progress: true,
                    cancelToken: cancelMetaPlaceSearchRequest.token
                })
                    .then(function (resp) {
                        if (resp.status == 200) {
                            return resp.data;
                        }
                    })
                    .catch(function (error) {
                        // handle error
                        if (error.__CANCEL__) {
                            console.log('<loadMetaPlace axios error> cancelled request')
                        } else {
                            console.log('<loadMetaPlace Axios error>', error);
                        }
                    })
                    .catch(function (error) {
                        // handle error
                        console.log('<loadMetaPlace Axios error>', error);
                    })
                    .then(function (data) {
                        metaPlaceLayer = L.geoJSON(data, {
                            style: polygon_style,
                            onEachFeature: function onEachFeature(feature, layer) {
                                var props = feature.properties;
                                var content = '<h3>MetaSite&nbsp;:&nbsp;'
                                    + props.name
                                    + '</h3><p><ul><li><b>Type</b>: '
                                    + (props.type_data ? props.type_data.descr : "Non défini")
                                    + '</li></ul> </p><div class="text-right"><div class="btn-group" role="group"><a type="button" class="btn btn-default btn-sm" align="center" style="color:white;" href="/metaplace/'
                                    + feature.id
                                    + '/detail" target="_blank"><i class="fa fa-fw fa-info-circle"></i></a><a type="button" class="btn btn-info btn-sm" align="center" style="color:white;" href="/metaplace/'
                                    + feature.id
                                    + '/update" target="_blank"><i class="fa fa-fw fa-edit"></i></a></div></div>';
                                layer.bindPopup(content);
                            }
                        });
                        metaPlacePolygons.addLayer(metaPlaceLayer).addTo(map);
                        metaPlacePolygons.bringToBack();
                    })
                    .catch(function (error) {
                        console.log('loadMetaPlace Leaflet error', error);
                    });

            };

            const loadDatas = function () {
                loadPlaces();
                loadMetaPlaces();
            }

            const clearLayers = function () {
                metaPlacePolygons.clearLayers();
                placeMarkers.clearLayers();
            }

            let debounce = null;

            map.on('moveend', function () {
                var currZoom = map.getZoom();
                if (currZoom >= 13) {
                    map.removeControl(overlayText);
                    clearTimeout(debounce);
                    debounce = setTimeout(loadDatas, 1000);
                } else {
                    clearLayers();
                    overlayText.addTo(map);
                }
            });

            var handler = function (e) {
                var position = e.currentTarget.getAttribute('data-position');
                console.log('position : ' + position)
                var zoom = e.currentTarget.getAttribute('data-zoom');
                console.log('zoom : ' + zoom)
                if (position && zoom) {
                    console.log('if position && zoom')
                    var location = position.split(';');
                    console.log('location : ' + location)
                    if (circlemarker !== null) {
                        map.removeLayer(circlemarker);
                    }
                    // var marker = L.marker(location).addTo(map);
                    circlemarker = new L.circleMarker(location,
                        {
                            radius: 20,
                            color: 'red',
                            fillColor: 'transparent',
                        })
                        .addTo(map)
                    // .bindPopup('<a class="button" href="popup link">lien</a>')
                    // .openPopup()
                    ;
                    console.log('circlemarker')
                    map.setView(location, 15, {
                        animation: true,
                    });
                    console.log('zoom')

                }
            }

            var elements = document.getElementsByClassName('map-navigation');

            for (var i = 0; i < elements.length; i++) {
                elements[i].onclick = handler;
            }


        });
    </script>
{% endblock %}
